﻿function divideUsingCallback(first, second, success, fail) {
    setTimeout(function () {
        if (second == 0) {
            fail(new Error('Divide by 0'));
        } else {
            success(first / second);
        }
    });
}

function divideUsingPromise(first, second) {
    return Q.fcall(function () {
        if (second == 0)
            throw new Error('Divide by 0');
        return Q(first / second);
    });
}

function divideEncapsulatingCallback(first, second) {
    var deferred = Q.defer();
    divideUsingCallback(first, second, deferred.resolve, deferred.reject);
    return deferred.promise;
}
