﻿function getCustomerWithCallback(name, success, fail) {
    setTimeout(function () {
        if (name) {
            success({ id: 1, name: name });
        } else {
            fail(new Error('Name is required'));
        }
    });
}

function getCustomerWithPromise(name) {
    return Q.fcall(function () {
        if (name)
            return Q({ id: 1, name: name });
        throw new Error('Name is required');
    });
}

function getRecentOrdersWithCallback(customerId, success, fail) {
    setTimeout(function () {
        if (customerId) {
            success([{ id: 11, totalAmount: 1100 }, { id: 12, totalAmount: 1200 }]);
        } else {
            fail(new Error('Customer Id is required'));
        }
    });
}

function getRecentOrdersWithPromise(customerId) {
    return Q.fcall(function () {
        if (customerId)
            return Q([{ id: 11, totalAmount: 1100 }, { id: 12, totalAmount: 1200 }]);
        throw new Error('Customer Id is required');
    });
}

function getSuggestionsFromOrdersWithCallback(orders, success, fail) {
    setTimeout(function () {
        if (orders) {
            success([{ id: 'A', name: 'Product A' }, { id: 'B', name: 'Product B' }, { id: 'C', name: 'Product C' }]);
        } else {
            fail(new Error('Orders are required'));
        }
    });
}

function getSuggestionsFromOrdersWithPromise(orders) {
    return Q.fcall(function () {
        if (orders)
            return Q([{ id: 'A', name: 'Product A' }, { id: 'B', name: 'Product B' }, { id: 'C', name: 'Product C' }]);
        throw new Error('Orders is required');
    });
}

function getSuggestionsForCustomerWithPromise(customerId) {
    return Q.fcall(function () {
        if (customerId)
            return Q([{ id: 'A', name: 'Product A' }, { id: 'B', name: 'Product B' }, { id: 'C', name: 'Product C' }]);
        throw new Error('Customer Id is required');
    });
}
